Assignments Assignments

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
Ray::DirectionalLight Class Reference

`#include <directionalLight.h>`

Inheritance diagram for Ray::DirectionalLight:

## Public Member Functions
std::string | name (void) const
Util::Point3D | getAmbient (Util::Ray3D ray, const class RayShapeIntersectionInfo &iInfo, const Material &material) const
Util::Point3D | getDiffuse (Util::Ray3D ray, const class RayShapeIntersectionInfo &iInfo, const Material &material) const
Util::Point3D | getSpecular (Util::Ray3D ray, const class RayShapeIntersectionInfo &iInfo, const Material &material) const
bool | isInShadow (const class RayShapeIntersectionInfo &iInfo, const class Shape &shape, unsigned int tIdx) const
Util::Point3D | transparency (const class RayShapeIntersectionInfo &iInfo, const class Shape &shape, Util::Point3D cLimit, unsigned int samples, unsigned int tIdx) const
void | drawOpenGL (int index, GLSLProgram *glslProgram) const
Public Member Functions inherited from Ray::Light
virtual | ~Light (void)

## Static Public Member Functions
static std::string | Directive (void)

## Private Member Functions
void | _write (std::ostream &stream) const
void | _read (std::istream &stream)

## Private Attributes
Util::Point3D | _direction

## Additional Inherited Members
Protected Attributes inherited from Ray::Light
Util::Point3D | _ambient
Util::Point3D | _diffuse
Util::Point3D | _specular

## Detailed Description

This class represents a directional light source. The light has no position in space and hence has no attenuation properties.

## Member Function Documentation

## ◆ _read()

void DirectionalLight::_read | ( | std::istream & | stream | ) |
| private virtual

This method reads the Light from the stream (excluding the starting directive)

Implements Ray::Light.

## ◆ _write()

void DirectionalLight::_write | ( | std::ostream & | stream | ) | const
| private virtual

This method writes the Light into the stream (including the starting directive)

Implements Ray::Light.

## ◆ Directive()

static std::string Ray::DirectionalLight::Directive | ( | void |  | ) |
| inline static

This static method returns the directive describing the Light.

## ◆ drawOpenGL()

void DirectionalLight::drawOpenGL | ( | int | index,
|  | GLSLProgram * | glslProgram ) const
| virtual

This method calls the necessary OpenGL commands to render the light. The index argument specifices the index of the light that is to be drawn.

Implements Ray::Light.

## ◆ getAmbient()

Point3D DirectionalLight::getAmbient | ( | Util::Ray3D | ray,
|  | const class RayShapeIntersectionInfo & | iInfo,
|  | const Material & | material ) const
| virtual

This method returns the ambient contribution of the light source to the specified hit location.

Implements Ray::Light.

## ◆ getDiffuse()

Point3D DirectionalLight::getDiffuse | ( | Util::Ray3D | ray,
|  | const class RayShapeIntersectionInfo & | iInfo,
|  | const Material & | material ) const
| virtual

This method returns the diffuse contribution of the light source to the specified hit location.

Implements Ray::Light.

## ◆ getSpecular()

Point3D DirectionalLight::getSpecular | ( | Util::Ray3D | ray,
|  | const class RayShapeIntersectionInfo & | iInfo,
|  | const Material & | material ) const
| virtual

This method returns the specular contribution of the light source to the specified hit location.

Implements Ray::Light.

## ◆ isInShadow()

bool DirectionalLight::isInShadow | ( | const class RayShapeIntersectionInfo & | iInfo,
|  | const class Shape & | shape,
|  | unsigned int | tIdx ) const
| virtual

This method tests if the intersection point represented by iInfo is in shadow from the light source. The returned value is either 0 if the the intersection point is not in shadow or 1 if it is.

Implements Ray::Light.

## ◆ name()

std::string Ray::DirectionalLight::name | ( | void |  | ) | const
| inline virtual

This method returns the name of the shape

Implements Ray::Light.

## ◆ transparency()

Point3D DirectionalLight::transparency | ( | const class RayShapeIntersectionInfo & | iInfo,
|  | const class Shape & | shape,
|  | Util::Point3D | cLimit,
|  | unsigned int | samples,
|  | unsigned int | tIdx ) const
| virtual

This method tests if the intersection point represented by iInfo is in partial shadow from the light source. A ray is cast from the hit location to the light source, and the transparency values are accumulated. If the light source is an area light source, multiple rays area cast to (uniformly randomly chosen positions on the area light sources and the transparency is set to the average of the transparency values over the samples. If the transparency value falls below cLimit, the testing terminates.

Implements Ray::Light.

## Member Data Documentation

## ◆ _direction

Util::Point3D Ray::DirectionalLight::_direction
| private

The direction the outgoing light rays

The documentation for this class was generated from the following files:

- Assignments/Ray/directionalLight.h
- Assignments/Ray/directionalLight.cpp
- Assignments/Ray/directionalLight.todo.cpp